package com.hfkj.dao;

import com.hfkj.entity.CouponDiscount;
import com.hfkj.entity.CouponDiscountExample.Criteria;
import com.hfkj.entity.CouponDiscountExample.Criterion;
import com.hfkj.entity.CouponDiscountExample;
import java.util.List;
import java.util.Map;
import org.apache.ibatis.jdbc.SQL;

public class CouponDiscountSqlProvider {

    public String countByExample(CouponDiscountExample example) {
        SQL sql = new SQL();
        sql.SELECT("count(*)").FROM("coupon_discount");
        applyWhere(sql, example, false);
        return sql.toString();
    }

    public String deleteByExample(CouponDiscountExample example) {
        SQL sql = new SQL();
        sql.DELETE_FROM("coupon_discount");
        applyWhere(sql, example, false);
        return sql.toString();
    }

    public String insertSelective(CouponDiscount record) {
        SQL sql = new SQL();
        sql.INSERT_INTO("coupon_discount");
        
        if (record.getPlatformCode() != null) {
            sql.VALUES("platform_code", "#{platformCode,jdbcType=VARCHAR}");
        }
        
        if (record.getName() != null) {
            sql.VALUES("`name`", "#{name,jdbcType=VARCHAR}");
        }
        
        if (record.getImg() != null) {
            sql.VALUES("img", "#{img,jdbcType=VARCHAR}");
        }
        
        if (record.getType() != null) {
            sql.VALUES("`type`", "#{type,jdbcType=INTEGER}");
        }
        
        if (record.getCondition() != null) {
            sql.VALUES("`condition`", "#{condition,jdbcType=DECIMAL}");
        }
        
        if (record.getPrice() != null) {
            sql.VALUES("price", "#{price,jdbcType=DECIMAL}");
        }
        
        if (record.getPercentage() != null) {
            sql.VALUES("percentage", "#{percentage,jdbcType=DECIMAL}");
        }
        
        if (record.getLimitNum() != null) {
            sql.VALUES("limit_num", "#{limitNum,jdbcType=INTEGER}");
        }
        
        if (record.getEffectiveDay() != null) {
            sql.VALUES("effective_day", "#{effectiveDay,jdbcType=INTEGER}");
        }
        
        if (record.getEffectiveNum() != null) {
            sql.VALUES("effective_num", "#{effectiveNum,jdbcType=INTEGER}");
        }
        
        if (record.getSalesEndTime() != null) {
            sql.VALUES("sales_end_time", "#{salesEndTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getCreateTime() != null) {
            sql.VALUES("create_time", "#{createTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getUpdateTime() != null) {
            sql.VALUES("update_time", "#{updateTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getOpId() != null) {
            sql.VALUES("op_id", "#{opId,jdbcType=BIGINT}");
        }
        
        if (record.getOpName() != null) {
            sql.VALUES("op_name", "#{opName,jdbcType=VARCHAR}");
        }
        
        if (record.getStatus() != null) {
            sql.VALUES("`status`", "#{status,jdbcType=INTEGER}");
        }
        
        if (record.getExt1() != null) {
            sql.VALUES("ext_1", "#{ext1,jdbcType=VARCHAR}");
        }
        
        if (record.getExt2() != null) {
            sql.VALUES("ext_2", "#{ext2,jdbcType=VARCHAR}");
        }
        
        if (record.getExt3() != null) {
            sql.VALUES("ext_3", "#{ext3,jdbcType=VARCHAR}");
        }
        
        return sql.toString();
    }

    public String selectByExample(CouponDiscountExample example) {
        SQL sql = new SQL();
        if (example != null && example.isDistinct()) {
            sql.SELECT_DISTINCT("id");
        } else {
            sql.SELECT("id");
        }
        sql.SELECT("platform_code");
        sql.SELECT("`name`");
        sql.SELECT("img");
        sql.SELECT("`type`");
        sql.SELECT("`condition`");
        sql.SELECT("price");
        sql.SELECT("percentage");
        sql.SELECT("limit_num");
        sql.SELECT("effective_day");
        sql.SELECT("effective_num");
        sql.SELECT("sales_end_time");
        sql.SELECT("create_time");
        sql.SELECT("update_time");
        sql.SELECT("op_id");
        sql.SELECT("op_name");
        sql.SELECT("`status`");
        sql.SELECT("ext_1");
        sql.SELECT("ext_2");
        sql.SELECT("ext_3");
        sql.FROM("coupon_discount");
        applyWhere(sql, example, false);
        
        if (example != null && example.getOrderByClause() != null) {
            sql.ORDER_BY(example.getOrderByClause());
        }
        
        return sql.toString();
    }

    public String updateByExampleSelective(Map<String, Object> parameter) {
        CouponDiscount record = (CouponDiscount) parameter.get("record");
        CouponDiscountExample example = (CouponDiscountExample) parameter.get("example");
        
        SQL sql = new SQL();
        sql.UPDATE("coupon_discount");
        
        if (record.getId() != null) {
            sql.SET("id = #{record.id,jdbcType=BIGINT}");
        }
        
        if (record.getPlatformCode() != null) {
            sql.SET("platform_code = #{record.platformCode,jdbcType=VARCHAR}");
        }
        
        if (record.getName() != null) {
            sql.SET("`name` = #{record.name,jdbcType=VARCHAR}");
        }
        
        if (record.getImg() != null) {
            sql.SET("img = #{record.img,jdbcType=VARCHAR}");
        }
        
        if (record.getType() != null) {
            sql.SET("`type` = #{record.type,jdbcType=INTEGER}");
        }
        
        if (record.getCondition() != null) {
            sql.SET("`condition` = #{record.condition,jdbcType=DECIMAL}");
        }
        
        if (record.getPrice() != null) {
            sql.SET("price = #{record.price,jdbcType=DECIMAL}");
        }
        
        if (record.getPercentage() != null) {
            sql.SET("percentage = #{record.percentage,jdbcType=DECIMAL}");
        }
        
        if (record.getLimitNum() != null) {
            sql.SET("limit_num = #{record.limitNum,jdbcType=INTEGER}");
        }
        
        if (record.getEffectiveDay() != null) {
            sql.SET("effective_day = #{record.effectiveDay,jdbcType=INTEGER}");
        }
        
        if (record.getEffectiveNum() != null) {
            sql.SET("effective_num = #{record.effectiveNum,jdbcType=INTEGER}");
        }
        
        if (record.getSalesEndTime() != null) {
            sql.SET("sales_end_time = #{record.salesEndTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getCreateTime() != null) {
            sql.SET("create_time = #{record.createTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getUpdateTime() != null) {
            sql.SET("update_time = #{record.updateTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getOpId() != null) {
            sql.SET("op_id = #{record.opId,jdbcType=BIGINT}");
        }
        
        if (record.getOpName() != null) {
            sql.SET("op_name = #{record.opName,jdbcType=VARCHAR}");
        }
        
        if (record.getStatus() != null) {
            sql.SET("`status` = #{record.status,jdbcType=INTEGER}");
        }
        
        if (record.getExt1() != null) {
            sql.SET("ext_1 = #{record.ext1,jdbcType=VARCHAR}");
        }
        
        if (record.getExt2() != null) {
            sql.SET("ext_2 = #{record.ext2,jdbcType=VARCHAR}");
        }
        
        if (record.getExt3() != null) {
            sql.SET("ext_3 = #{record.ext3,jdbcType=VARCHAR}");
        }
        
        applyWhere(sql, example, true);
        return sql.toString();
    }

    public String updateByExample(Map<String, Object> parameter) {
        SQL sql = new SQL();
        sql.UPDATE("coupon_discount");
        
        sql.SET("id = #{record.id,jdbcType=BIGINT}");
        sql.SET("platform_code = #{record.platformCode,jdbcType=VARCHAR}");
        sql.SET("`name` = #{record.name,jdbcType=VARCHAR}");
        sql.SET("img = #{record.img,jdbcType=VARCHAR}");
        sql.SET("`type` = #{record.type,jdbcType=INTEGER}");
        sql.SET("`condition` = #{record.condition,jdbcType=DECIMAL}");
        sql.SET("price = #{record.price,jdbcType=DECIMAL}");
        sql.SET("percentage = #{record.percentage,jdbcType=DECIMAL}");
        sql.SET("limit_num = #{record.limitNum,jdbcType=INTEGER}");
        sql.SET("effective_day = #{record.effectiveDay,jdbcType=INTEGER}");
        sql.SET("effective_num = #{record.effectiveNum,jdbcType=INTEGER}");
        sql.SET("sales_end_time = #{record.salesEndTime,jdbcType=TIMESTAMP}");
        sql.SET("create_time = #{record.createTime,jdbcType=TIMESTAMP}");
        sql.SET("update_time = #{record.updateTime,jdbcType=TIMESTAMP}");
        sql.SET("op_id = #{record.opId,jdbcType=BIGINT}");
        sql.SET("op_name = #{record.opName,jdbcType=VARCHAR}");
        sql.SET("`status` = #{record.status,jdbcType=INTEGER}");
        sql.SET("ext_1 = #{record.ext1,jdbcType=VARCHAR}");
        sql.SET("ext_2 = #{record.ext2,jdbcType=VARCHAR}");
        sql.SET("ext_3 = #{record.ext3,jdbcType=VARCHAR}");
        
        CouponDiscountExample example = (CouponDiscountExample) parameter.get("example");
        applyWhere(sql, example, true);
        return sql.toString();
    }

    public String updateByPrimaryKeySelective(CouponDiscount record) {
        SQL sql = new SQL();
        sql.UPDATE("coupon_discount");
        
        if (record.getPlatformCode() != null) {
            sql.SET("platform_code = #{platformCode,jdbcType=VARCHAR}");
        }
        
        if (record.getName() != null) {
            sql.SET("`name` = #{name,jdbcType=VARCHAR}");
        }
        
        if (record.getImg() != null) {
            sql.SET("img = #{img,jdbcType=VARCHAR}");
        }
        
        if (record.getType() != null) {
            sql.SET("`type` = #{type,jdbcType=INTEGER}");
        }
        
        if (record.getCondition() != null) {
            sql.SET("`condition` = #{condition,jdbcType=DECIMAL}");
        }
        
        if (record.getPrice() != null) {
            sql.SET("price = #{price,jdbcType=DECIMAL}");
        }
        
        if (record.getPercentage() != null) {
            sql.SET("percentage = #{percentage,jdbcType=DECIMAL}");
        }
        
        if (record.getLimitNum() != null) {
            sql.SET("limit_num = #{limitNum,jdbcType=INTEGER}");
        }
        
        if (record.getEffectiveDay() != null) {
            sql.SET("effective_day = #{effectiveDay,jdbcType=INTEGER}");
        }
        
        if (record.getEffectiveNum() != null) {
            sql.SET("effective_num = #{effectiveNum,jdbcType=INTEGER}");
        }
        
        if (record.getSalesEndTime() != null) {
            sql.SET("sales_end_time = #{salesEndTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getCreateTime() != null) {
            sql.SET("create_time = #{createTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getUpdateTime() != null) {
            sql.SET("update_time = #{updateTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getOpId() != null) {
            sql.SET("op_id = #{opId,jdbcType=BIGINT}");
        }
        
        if (record.getOpName() != null) {
            sql.SET("op_name = #{opName,jdbcType=VARCHAR}");
        }
        
        if (record.getStatus() != null) {
            sql.SET("`status` = #{status,jdbcType=INTEGER}");
        }
        
        if (record.getExt1() != null) {
            sql.SET("ext_1 = #{ext1,jdbcType=VARCHAR}");
        }
        
        if (record.getExt2() != null) {
            sql.SET("ext_2 = #{ext2,jdbcType=VARCHAR}");
        }
        
        if (record.getExt3() != null) {
            sql.SET("ext_3 = #{ext3,jdbcType=VARCHAR}");
        }
        
        sql.WHERE("id = #{id,jdbcType=BIGINT}");
        
        return sql.toString();
    }

    protected void applyWhere(SQL sql, CouponDiscountExample example, boolean includeExamplePhrase) {
        if (example == null) {
            return;
        }
        
        String parmPhrase1;
        String parmPhrase1_th;
        String parmPhrase2;
        String parmPhrase2_th;
        String parmPhrase3;
        String parmPhrase3_th;
        if (includeExamplePhrase) {
            parmPhrase1 = "%s #{example.oredCriteria[%d].allCriteria[%d].value}";
            parmPhrase1_th = "%s #{example.oredCriteria[%d].allCriteria[%d].value,typeHandler=%s}";
            parmPhrase2 = "%s #{example.oredCriteria[%d].allCriteria[%d].value} and #{example.oredCriteria[%d].criteria[%d].secondValue}";
            parmPhrase2_th = "%s #{example.oredCriteria[%d].allCriteria[%d].value,typeHandler=%s} and #{example.oredCriteria[%d].criteria[%d].secondValue,typeHandler=%s}";
            parmPhrase3 = "#{example.oredCriteria[%d].allCriteria[%d].value[%d]}";
            parmPhrase3_th = "#{example.oredCriteria[%d].allCriteria[%d].value[%d],typeHandler=%s}";
        } else {
            parmPhrase1 = "%s #{oredCriteria[%d].allCriteria[%d].value}";
            parmPhrase1_th = "%s #{oredCriteria[%d].allCriteria[%d].value,typeHandler=%s}";
            parmPhrase2 = "%s #{oredCriteria[%d].allCriteria[%d].value} and #{oredCriteria[%d].criteria[%d].secondValue}";
            parmPhrase2_th = "%s #{oredCriteria[%d].allCriteria[%d].value,typeHandler=%s} and #{oredCriteria[%d].criteria[%d].secondValue,typeHandler=%s}";
            parmPhrase3 = "#{oredCriteria[%d].allCriteria[%d].value[%d]}";
            parmPhrase3_th = "#{oredCriteria[%d].allCriteria[%d].value[%d],typeHandler=%s}";
        }
        
        StringBuilder sb = new StringBuilder();
        List<Criteria> oredCriteria = example.getOredCriteria();
        boolean firstCriteria = true;
        for (int i = 0; i < oredCriteria.size(); i++) {
            Criteria criteria = oredCriteria.get(i);
            if (criteria.isValid()) {
                if (firstCriteria) {
                    firstCriteria = false;
                } else {
                    sb.append(" or ");
                }
                
                sb.append('(');
                List<Criterion> criterions = criteria.getAllCriteria();
                boolean firstCriterion = true;
                for (int j = 0; j < criterions.size(); j++) {
                    Criterion criterion = criterions.get(j);
                    if (firstCriterion) {
                        firstCriterion = false;
                    } else {
                        sb.append(" and ");
                    }
                    
                    if (criterion.isNoValue()) {
                        sb.append(criterion.getCondition());
                    } else if (criterion.isSingleValue()) {
                        if (criterion.getTypeHandler() == null) {
                            sb.append(String.format(parmPhrase1, criterion.getCondition(), i, j));
                        } else {
                            sb.append(String.format(parmPhrase1_th, criterion.getCondition(), i, j,criterion.getTypeHandler()));
                        }
                    } else if (criterion.isBetweenValue()) {
                        if (criterion.getTypeHandler() == null) {
                            sb.append(String.format(parmPhrase2, criterion.getCondition(), i, j, i, j));
                        } else {
                            sb.append(String.format(parmPhrase2_th, criterion.getCondition(), i, j, criterion.getTypeHandler(), i, j, criterion.getTypeHandler()));
                        }
                    } else if (criterion.isListValue()) {
                        sb.append(criterion.getCondition());
                        sb.append(" (");
                        List<?> listItems = (List<?>) criterion.getValue();
                        boolean comma = false;
                        for (int k = 0; k < listItems.size(); k++) {
                            if (comma) {
                                sb.append(", ");
                            } else {
                                comma = true;
                            }
                            if (criterion.getTypeHandler() == null) {
                                sb.append(String.format(parmPhrase3, i, j, k));
                            } else {
                                sb.append(String.format(parmPhrase3_th, i, j, k, criterion.getTypeHandler()));
                            }
                        }
                        sb.append(')');
                    }
                }
                sb.append(')');
            }
        }
        
        if (sb.length() > 0) {
            sql.WHERE(sb.toString());
        }
    }
}